package agora.activities;

import java.io.IOException;
import java.net.URISyntaxException;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import org.apache.http.client.ClientProtocolException;

import agora.classes.Notification;
import agora.classes.Space;
import agora.classes.User;
import agora.rest.AgoraAPI;
import android.app.Activity;
import android.app.Dialog;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.os.AsyncTask;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.Toast;

public class Checkin extends Activity {

	private AgoraAPI api = new AgoraAPI();
	private List<Space> spaces;
	private User user;
	private ProgressDialog progressCourses;
	private ArrayAdapter<String> adapter;
	private ListView lv;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);

		setContentView(R.layout.checkin_activity);

		Bundle extras = getIntent().getExtras();
		if (extras != null) {
			user = (User) extras.get("user");
		}

		progressCourses = new ProgressDialog(this);

		lv = (ListView) findViewById(R.id.listView1);
		spaces = new ArrayList<Space>();
		new getSpaceFromAPI().execute();

		lv.setTextFilterEnabled(true);

		final Context context = this;
		lv.setOnItemClickListener(new OnItemClickListener() {
			public void onItemClick(AdapterView<?> parent, View view,
					final int position, long id) {
				// When clicked, show a toast with the TextView text

				final Dialog dialog = new Dialog(context);
				dialog.setContentView(R.layout.popup_window);
				dialog.setTitle("Afegir Comentari");

				Button dialogButton_create = (Button) dialog
						.findViewById(R.id.dialogButtonCreate);
				dialogButton_create.setOnClickListener(new OnClickListener() {
					public void onClick(View v) {
						dialog.dismiss();
						EditText edt_comment = (EditText) dialog
								.findViewById(R.id.EditText_comment);

						String comment = edt_comment.getText().toString();
						if (comment.compareTo("") == 0)
							comment = "No comment";

						Date dt = new Date();
						dt.setYear(2012);
						Notification n = new Notification(user.getUsername(),
								dt, spaces.get(position).getSite(), comment);

						new sentNotificationToAPI().execute(n);

						clickButton1(null);

						Toast.makeText(getApplicationContext(),
								"send with comment ", Toast.LENGTH_SHORT)
								.show();
					}
				});

				Button dialogButton_cancel = (Button) dialog
						.findViewById(R.id.dialogButtonCancel);
				// if button is clicked, close the custom dialog
				dialogButton_cancel.setOnClickListener(new OnClickListener() {
					public void onClick(View v) {
						dialog.dismiss();
					}

				});

				dialog.show();
				// ---------------**************-----------------------

			}

		});
	}

	private class sentNotificationToAPI extends
			AsyncTask<Notification, Void, Void> {
		public void onPreExecute() {
			progressCourses.setMessage("Enviant Notificaci");
			progressCourses.setTitle("Enviant");
			progressCourses.show();
		}

		public Void doInBackground(Notification... params) {
			try {
				api.addNotification(params[0]);
			} catch (ClientProtocolException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IllegalStateException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (URISyntaxException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			return null;
		}

		public void onPostExecute(Void unused) {
			progressCourses.dismiss();
		}

	}

	private class getSpaceFromAPI extends AsyncTask<Void, Void, Void> {

		List<String> spaces_name = new ArrayList<String>();

		public void onPreExecute() {
			progressCourses.setMessage("Recopilant Espais");
			progressCourses.setTitle("Rebent");
			progressCourses.show();
		}

		public Void doInBackground(Void... params) {
			try {
				spaces = api.getSpaces();
				for (int i = 0; i < spaces.size(); i++) {
					spaces_name.add(spaces.get(i).getSite());
				}
			} catch (ClientProtocolException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			return null;
		}

		public void onPostExecute(Void unused) {
			progressCourses.dismiss();
			adapter = new ArrayAdapter<String>(getApplicationContext(),
					android.R.layout.simple_list_item_1, spaces_name);
			lv.setAdapter(adapter);
		}

	}

	public void sendMessage(View v) {
		Intent intent = new Intent(this, SendMessage.class);
		intent.putExtra("user", user);
		startActivity(intent);
	}

	public void clickButton1(View v) {
		Intent intent = new Intent(this, MainMenu.class);
		intent.putExtra("user", user);
		startActivity(intent);
	}
}
