package agora.activities;

import java.io.IOException;
import java.util.List;

import org.apache.http.client.ClientProtocolException;

import agora.classes.Notification;
import agora.classes.User;
import agora.rest.AgoraAPI;
import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Intent;
import android.os.AsyncTask;
import android.os.Bundle;
import android.view.View;
import android.widget.TextView;
import android.widget.Toast;

public class Login extends Activity {

	private ProgressDialog progressLogin;
	private AgoraAPI api;

	TextView et_userName;
	TextView et_userPass;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.login_activity);
		progressLogin = new ProgressDialog(this);

		et_userName = (TextView) findViewById(R.id.et_userName);
		et_userPass = (TextView) findViewById(R.id.et_userPass);

		et_userName.setText("Laura");
		et_userPass.setText("1234");

		api = new AgoraAPI();
	}

	public void login(View v) {
		new loginAPI().execute();
	}

	private class loginAPI extends AsyncTask<Void, Void, Void> {

		Boolean login = false;
		String name, pass;

		public void onPreExecute() {
			progressLogin.setMessage("Carregant dades");
			progressLogin.setTitle("Accedint");
			progressLogin.show();

			name = et_userName.getText().toString();
			pass = et_userPass.getText().toString();
		}

		public Void doInBackground(Void... unused) {
			try {
				// Thread.sleep(2000);

				login = api.login(name, pass);
				// login = api.login("Laura", "1234");

			} catch (ClientProtocolException e) {
				e.printStackTrace();
			} catch (IOException e) {
				e.printStackTrace();
			}

			return null;
		}

		public void onPostExecute(Void unused) {
			if (login) {
				// User user = new User("Laura", "1234");
				User user = new User(name, pass);
				Intent intent = new Intent(Login.this, MainMenu.class);
				intent.putExtra("user", user);
				startActivity(intent);
			} else
				Toast.makeText(getApplicationContext(), "Error de login",
						Toast.LENGTH_SHORT).show();

			progressLogin.dismiss();

		}
	}

}