package agora.activities;

import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.text.DateFormat;
import java.util.Date;
import java.util.List;
import java.util.Vector;

import org.apache.http.client.ClientProtocolException;

import agora.classes.Notification;
import agora.classes.User;
import agora.rest.AgoraAPI;
import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.content.res.AssetManager;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.AsyncTask;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.TextView;

public class MainMenu extends Activity {

	private LayoutInflater mInflater;

	private AgoraAPI api;
	private User user;
	private ProgressDialog progressNotifications;
	private List<Notification> not_list = null;

	private ListView lv;
	private Vector<RowData> data;
	private CustomAdapter adapter;

	private class RowData {
		protected int mId;
		protected String mName;
		protected Bitmap mImg;
		protected String mMesage;

		RowData(int id, String name, String mesage, Bitmap bitmap) {
			mId = id;
			mName = name;
			mMesage = mesage;
			mImg = bitmap;
		}
	}

	private class CustomAdapter extends ArrayAdapter<RowData> {

		public CustomAdapter(Context context, int resource,
				int textViewResourceId, List<RowData> objects) {

			super(context, resource, textViewResourceId, objects);
		}

		@Override
		public View getView(int position, View convertView, ViewGroup parent) {

			ViewHolder holder = null;
			TextView name = null;
			TextView mesage = null;
			ImageView i11 = null;

			RowData rowData = getItem(position);
			if (null == convertView) {
				convertView = mInflater.inflate(R.layout.notification_item,
						null);
				holder = new ViewHolder(convertView);
				convertView.setTag(holder);
			}
			holder = (ViewHolder) convertView.getTag();
			name = holder.gettitle();
			name.setText(rowData.mName);

			mesage = holder.getMesage();
			mesage.setText(rowData.mMesage);

			i11 = holder.getImage();
			i11.setImageBitmap(rowData.mImg);

			return convertView;
		}

		private class ViewHolder {
			private View mRow;
			private TextView title = null;
			private TextView mesage = null;
			private ImageView i11 = null;

			public ViewHolder(View row) {
				mRow = row;
			}

			public TextView gettitle() {
				if (null == title) {
					title = (TextView) mRow
							.findViewById(R.id.notification_name);
				}
				return title;
			}

			public TextView getMesage() {
				if (null == mesage) {
					mesage = (TextView) mRow
							.findViewById(R.id.notification_message);
				}
				return mesage;
			}

			public ImageView getImage() {
				if (null == i11) {
					i11 = (ImageView) mRow.findViewById(R.id.notification_img);
				}
				return i11;
			}
		}
	}

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);

		setContentView(R.layout.referenced_activity);
		progressNotifications = new ProgressDialog(this);
		api = new AgoraAPI();

		Bundle extras = getIntent().getExtras();
		if (extras != null) {
			user = (User) extras.get("user");
		}

		new getNotificationsFromAPI().execute();

		// Vector<RowData> data = new Vector<RowData>();
		//
		// // not_list = api.getNotifications();
		//
		// int size = not_list.size() - 1;
		// for (int i = size; i >= 0; i--) {
		//
		// // Get Image
		// Bitmap bitmap = BitmapFactory.decodeResource(getResources(),
		// R.drawable.ic_launcher);
		//
		// // Get name
		// String name = not_list.get(i).getUsername();
		//
		// Date dt = not_list.get(i).getDate();
		// String dateTimeString = "";
		//
		// if (dt != null) {
		// dateTimeString = DateFormat.getDateTimeInstance().format(dt);
		//
		// }
		//
		// // Get Mesage
		// String message = " Dia: " + dateTimeString + "\n Des de: "
		// + not_list.get(i).getSpace() + "\n Diu: "
		// + not_list.get(i).getMessage();
		//
		// // int d = 0, m = 0, y = 0, h = 0, min = 0;
		// // if (dt != null) {
		// // y = dt.getYear();
		// // m = dt.getMonth();
		// // d = dt.getDate();
		// // h = dt.getHours();
		// // min = dt.getMinutes();
		// // }
		// //
		// // // Get Mesage
		// // String message = " Dia: " + d + "/" + m + "/" + y + " "
		// // + h + ":" + min + "\n Des de: "
		// // + not_list.get(i).getSpace() + "\n Diu: "
		// // + not_list.get(i).getMessage();
		//
		// RowData rd = new RowData(i, name, message, bitmap);
		// data.add(rd);
		// }

		mInflater = (LayoutInflater) getSystemService(Activity.LAYOUT_INFLATER_SERVICE);
		lv = (ListView) findViewById(R.id.list);
		adapter = new CustomAdapter(this, R.layout.notification_item,
				R.id.notification_name, data);
		// lv.setAdapter(adapter);

	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		menu.add("Actualizar");
		return super.onCreateOptionsMenu(menu);
	}

	final Context context = this;

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		if (item.getTitle().equals("Actualizar")) {
			onCreate(null);
		}
		return super.onOptionsItemSelected(item);
	}

	public void sendMessage(View v) {
		Intent intent = new Intent(this, SendMessage.class);
		intent.putExtra("user", user);
		startActivity(intent);
	}

	public void clickCheckin(View v) {
		Intent intent = new Intent(this, Checkin.class);
		intent.putExtra("user", user);
		startActivity(intent);
	}

	private class getNotificationsFromAPI extends AsyncTask<Void, Void, Void> {
		public void onPreExecute() {
			progressNotifications.setMessage("Obtenint notificacions");
			progressNotifications.setTitle("Accedint");
			progressNotifications.show();
		}

		public Void doInBackground(Void... unused) {
			try {
				not_list = api.getNotifications();

				data = new Vector<RowData>();

				// not_list = api.getNotifications();

				int size = not_list.size() - 1;
				for (int i = size; i >= 0; i--) {

					// Get Image
					Bitmap bitmap = BitmapFactory.decodeResource(
							getResources(), R.drawable.ic_launcher);

					AssetManager am = getResources().getAssets();
					try {
						InputStream is = am.open(not_list.get(i).getUsername()
								+ ".jpg");
						bitmap = BitmapFactory.decodeStream(is);
					} catch (IOException e) {
					}

					// Get name
					String name = not_list.get(i).getUsername();

					Date dt = not_list.get(i).getDate();

					// String dateTimeString = "";
					// if (dt != null) {
					// dateTimeString = DateFormat.getDateTimeInstance()
					// .format(dt);
					// }

					// // Get Mesage
					// String message = " Dia: " + dateTimeString +
					// "\n Des de: "
					// + not_list.get(i).getSpace() + "\n Diu: "
					// + not_list.get(i).getMessage();

					int d = 0, m = 0, y = 0, h = 0, min = 0;
					if (dt != null) {
						y = dt.getYear();
						m = dt.getMonth();
						d = dt.getDate();
						h = dt.getHours();
						min = dt.getMinutes();
					}

					// Get Mesage
					String message = " Dia: " + d + "/" + m + "/" + y + " " + h
							+ ":" + min;

					if (not_list.get(i).getSpace() != null) {
						message = message + "\n Des de: "
								+ not_list.get(i).getSpace();
					}

					message = message + "\n Diu: "
							+ not_list.get(i).getMessage();

					RowData rd = new RowData(i, name, message, bitmap);
					data.add(rd);

				}
			} catch (ClientProtocolException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}

			return null;
		}

		public void onPostExecute(Void unused) {
			progressNotifications.dismiss();
			adapter = new CustomAdapter(getApplicationContext(),
					R.layout.notification_item, R.id.notification_name, data);
			lv.setAdapter(adapter);
		}
	}
}
