package agora.activities;

import java.io.IOException;
import java.io.InputStream;
import java.net.URISyntaxException;
import java.util.ArrayList;
import java.util.List;
import java.util.Vector;

import org.apache.http.client.ClientProtocolException;

import agora.classes.Course;
import agora.classes.Notification;
import agora.classes.User;
import agora.rest.AgoraAPI;
import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.content.res.AssetManager;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.AsyncTask;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.AdapterView.OnItemSelectedListener;
import android.widget.ArrayAdapter;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

public class SendMessage extends Activity {
	private AgoraAPI api;

	private String courseName;

	private User user;
	private ProgressDialog progressCourses;
	private Spinner spinner;
	private ListView lv;
	private EditText editText;
	private LayoutInflater mInflater;

	private Vector<RowData> data;
	private CustomAdapter adapter;

	private List<Course> courses;
	private List<User> users;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);

		setContentView(R.layout.sendmessage_activity);
		spinner = (Spinner) findViewById(R.id.spinner1);
		editText = (EditText) findViewById(R.id.editText1);
		mInflater = (LayoutInflater) getSystemService(Activity.LAYOUT_INFLATER_SERVICE);
		lv = (ListView) findViewById(R.id.listView1);

		Bundle extras = getIntent().getExtras();
		if (extras != null) {
			user = (User) extras.get("user");
		}
		api = new AgoraAPI();
		progressCourses = new ProgressDialog(this);
		new getCoursesFromAPI().execute();
		
		spinner.setOnItemSelectedListener(new OnItemSelectedListener() {

			public void onItemSelected(AdapterView<?> selected, View arg1,
					int position, long arg3) {
				Toast.makeText(
						selected.getContext(),
						"El curs escollit s "
								+ selected.getItemAtPosition(position)
										.toString(), Toast.LENGTH_LONG).show();
				courseName = selected.getItemAtPosition(position).toString();
				new getStudentsFromAPI().execute();
			}

			public void onNothingSelected(AdapterView<?> arg0) {
				// TODO Auto-generated method stub

			}
		});

		lv.setOnItemClickListener(new OnItemClickListener() {
			public void onItemClick(AdapterView<?> parent, View view,
					int position, long id) {

				String text = editText.getText().toString();

				if (text.indexOf(courseName) == -1) {
					text = "@" + courseName + " " + text + " @"
							+ users.get(position).getUsername();
				} else {
					text = text + " @" + users.get(position).getUsername();
				}

				// if (text.indexOf(courseName) == -1) {
				// text = "@" + courseName + " " + text + " @"
				// + ((TextView) view).getText();
				// } else {
				// text = text + " @" + ((TextView) view).getText();
				// }
				// editText.setText("@"+courseName+" "+editText.getText() +
				// " @"
				// + ((TextView) view).getText());
				editText.setText(text);
			}
		});

		ImageView imgGood = (ImageView) findViewById(R.id.imageGood);
		imgGood.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				editText.setText(editText.getText() + " #BonComportament");
			}
		});

		ImageView imgColab = (ImageView) findViewById(R.id.imageColaborative);
		imgColab.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				editText.setText(editText.getText() + " #Collaboratiu");
			}
		});

		ImageView imgFault = (ImageView) findViewById(R.id.imageFault);
		imgFault.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				editText.setText(editText.getText() + " #FaltaMaterial");
			}
		});

		ImageView imgNoHomework = (ImageView) findViewById(R.id.imageNoHomework);
		imgNoHomework.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				editText.setText(editText.getText() + " #FaltaDeures");
			}
		});

		ImageView imgOut = (ImageView) findViewById(R.id.imageOut);
		imgNoHomework.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				editText.setText(editText.getText() + " #Expulsat");
			}
		});
	}

	public void sendMessage(View v) {
		String message = editText.getText().toString();
		Notification notification = new Notification(this.user.getUsername(),
				message, null);
		new sentNotificationToAPI().execute(notification);
	}

	public void clickCheckin(View v) {
		Intent intent = new Intent(this, Checkin.class);
		intent.putExtra("user", user);
		startActivity(intent);
	}

	private class getCoursesFromAPI extends AsyncTask<Void, Void, Void> {
		public void onPreExecute() {
			progressCourses.setMessage("Obtenint Cursos");
			progressCourses.setTitle("Accedint");
			progressCourses.show();
		}

		public Void doInBackground(Void... unused) {
			try {
				courses = api.getCourses();
				System.out.println(courses.size());
			} catch (ClientProtocolException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			return null;
		}

		public void onPostExecute(Void unused) {
			progressCourses.dismiss();

			List<String> coursesString = new ArrayList<String>();

			for (Course course : courses) {
				coursesString.add(course.getName());
			}
			
			ArrayAdapter<String> adapter = new ArrayAdapter<String>(
					getApplicationContext(),
					android.R.layout.simple_spinner_item, coursesString);
			spinner.setPrompt("Tria un curs");
			adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
			spinner.setAdapter(adapter);
		}
	}

	private class getStudentsFromAPI extends AsyncTask<Void, Void, Void> {
		public void onPreExecute() {
			progressCourses.setMessage("Obtenint Estudiants");
			progressCourses.setTitle("Accedint");
			progressCourses.show();
		}

		public Void doInBackground(Void... params) {
			try {
				users = api.findUsers(courseName);

				data = new Vector<RowData>();

				for (User user : users) {
					// Get Image
					Bitmap bitmap = BitmapFactory.decodeResource(
							getResources(), R.drawable.ic_launcher);

					AssetManager am = getResources().getAssets();
					try {
						InputStream is = am.open(user.getUsername() + ".jpg");
						bitmap = BitmapFactory.decodeStream(is);
					} catch (IOException e) {
					}
					RowData rd = new RowData(0, user.getUsername(), bitmap);
					data.add(rd);
				}

			} catch (ClientProtocolException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			return null;
		}

		public void onPostExecute(Void unused) {
			progressCourses.dismiss();

			adapter = new CustomAdapter(getApplicationContext(),
					R.layout.notification_item, R.id.student_name, data);
			lv.setAdapter(adapter);

			// List<String> usersString = new ArrayList<String>();
			// for (User user : users) {
			// usersString.add(user.getUsername());
			// }
			//
			// ArrayAdapter<String> adapter = new ArrayAdapter<String>(
			// getApplicationContext(),
			// android.R.layout.simple_list_item_1, usersString);
			// lv.setAdapter(adapter);
			// lv.setOnItemClickListener(new OnItemClickListener() {
			// public void onItemClick(AdapterView<?> parent, View view,
			// int position, long id) {
			//
			// String text = editText.getText().toString();
			//
			// if (text.indexOf(courseName) == -1) {
			// text = "@" + courseName + " " + text + " @"
			// + ((TextView) view).getText();
			// } else {
			// text = text + " @" + ((TextView) view).getText();
			// }
			// // editText.setText("@"+courseName+" "+editText.getText() +
			// // " @"
			// // + ((TextView) view).getText());
			// editText.setText(text);
			// }
			// });
		}

	}

	private class sentNotificationToAPI extends
			AsyncTask<Notification, Void, Void> {
		public void onPreExecute() {
			progressCourses.setMessage("Enviant Notificaci");
			progressCourses.setTitle("Enviant");
			progressCourses.show();
		}

		public Void doInBackground(Notification... params) {
			try {
				api.addNotification(params[0]);
			} catch (ClientProtocolException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IllegalStateException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (URISyntaxException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			return null;
		}

		public void onPostExecute(Void unused) {
			progressCourses.dismiss();
			finish();
		}

	}

	private class RowData {
		protected int mId;
		protected String mName;
		protected Bitmap mImg;

		RowData(int id, String name, Bitmap bitmap) {
			mId = id;
			mName = name;
			mImg = bitmap;
		}
	}

	private class CustomAdapter extends ArrayAdapter<RowData> {

		public CustomAdapter(Context context, int resource,
				int textViewResourceId, List<RowData> objects) {

			super(context, resource, textViewResourceId, objects);
		}

		@Override
		public View getView(int position, View convertView, ViewGroup parent) {

			ViewHolder holder = null;
			TextView name = null;
			ImageView i11 = null;

			RowData rowData = getItem(position);
			if (null == convertView) {
				convertView = mInflater
						.inflate(R.layout.sendmessage_item, null);
				holder = new ViewHolder(convertView);
				convertView.setTag(holder);
			}
			holder = (ViewHolder) convertView.getTag();
			name = holder.gettitle();
			name.setText(rowData.mName);

			i11 = holder.getImage();
			i11.setImageBitmap(rowData.mImg);

			return convertView;
		}

		private class ViewHolder {
			private View mRow;
			private TextView title = null;
			private ImageView i11 = null;

			public ViewHolder(View row) {
				mRow = row;
			}

			public TextView gettitle() {
				if (null == title) {
					title = (TextView) mRow.findViewById(R.id.student_name);
				}
				return title;
			}

			public ImageView getImage() {
				if (null == i11) {
					i11 = (ImageView) mRow.findViewById(R.id.notification_img);
				}
				return i11;
			}
		}
	}

}
