package agora.classes;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.Id;
import javax.persistence.ManyToMany;
import javax.persistence.OneToMany;
import javax.xml.bind.annotation.XmlRootElement;

@XmlRootElement
@Entity
public class Course implements Serializable{

	private String name;
	// LListat de professors del curs
	private List<User> teachers = new ArrayList<User>();

	// private List<User> students = new ArrayList<User>();

	// Llistat de alumnes del course (temporalment inoperatiu)
	// private List<Student> students = new ArrayList<Student>();

	public Course() {
	}

	public Course(String name) {
		super();
		this.name = name;
	}

	@Id
	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	/*
	 * El FetchType.LAZY permetra rebre la llista de usuaris completa. Pero si
	 * no es guarda en un objecte, al tancar la sessi es perdr tot. Aixo
	 * permet no arrastrar tots els objectes de la classe USER
	 */
	@ManyToMany(cascade = CascadeType.ALL, fetch = FetchType.LAZY)
	public List<User> getTeachers() {
		return teachers;
	}

	public void setTeachers(List<User> teachers) {
		this.teachers = teachers;
	}

	// @ManyToMany(cascade = CascadeType.ALL, fetch = FetchType.LAZY)
	// public List<User> getStudents() {
	// return students;
	// }
	//
	// public void setStudents(List<User> students) {
	// this.students = students;
	// }

}
