package agora.database;

import java.io.Serializable;
import java.util.List;

import org.hibernate.Query;

import agora.classes.Course;
import agora.classes.Notification;
import agora.classes.Space;
import agora.classes.User;
import agora.singletons.Singleton;

public class ConnectorControl implements Serializable {

	private DBconnector dbc;

	// Constructor
	public ConnectorControl() {
		dbc = new DBconnector();

	}

	public boolean login(String username, String password) {
		return dbc.login(username, password);
	}

	public User getUser(String username) {
		return dbc.getUser(username);
	}

	public List<Course> getCourses() {
		return dbc.getCourses();
	}

	public List<User> getCourseUsers(String course) {
//		return dbc.getCourseUsers(null);
		return dbc.getCourseUsers(course);
	}

	public List<Notification> getNotifications() {
		return dbc.getNotifications();
	}

	public void setNotification(Notification n) {
		dbc.setNotification(n);
	}

	public List<Space> getSpaces() {		
		return dbc.getSpaces();
	}
}
