package agora.database;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.hibernate.cfg.AnnotationConfiguration;
import org.hibernate.tool.hbm2ddl.SchemaExport;

import agora.classes.Course;
import agora.classes.ItemAgenda;
import agora.classes.Notification;
import agora.classes.Space;
import agora.classes.User;

public class CreateTables_v2 {

	static AnnotationConfiguration config;

	public static void Create() {
		config = new AnnotationConfiguration();
		config.addAnnotatedClass(User.class);
		// config.addAnnotatedClass(ItemAgenda.class);
		config.addAnnotatedClass(Course.class);
		config.addAnnotatedClass(Space.class);
		config.addAnnotatedClass(Notification.class);
		config.configure("hibernate.cfg.xml");
		new SchemaExport(config).create(true, true); // crear las tablas

	}

	public static void Insert() {
		SessionFactory factory = config.buildSessionFactory();
		Session session = factory.getCurrentSession();
		session.beginTransaction();

		// List<ItemAgenda> itemAgenda = new ArrayList<ItemAgenda>();

		Space space1 = new Space("Taller de Tecnologia");
		Space space2 = new Space("Aula 123");
		Space space3 = new Space("Lab Quimica");
		Space space4 = new Space("Sala de Conferencies");
		Space space5 = new Space("Pati");
		Space space6 = new Space("Biblioteca");

		session.save(space1);
		session.save(space2);
		session.save(space3);
		session.save(space4);
		session.save(space5);
		session.save(space6);

		Course course1 = new Course("1rESO");
		Course course2 = new Course("2nESO");
		Course course3 = new Course("3rESO");
		Course course4 = new Course("4tESO");

		// User josep = new User("Josep", "1234");
		// User miquel = new User("Miquel", "1234");
		// User marti = new User("Marti", "1234");
		// User pol = new User("Pol", "1234");
		//
		// List<User> studentsCourse1 = new ArrayList<User>();
		// studentsCourse1.add(josep);
		// studentsCourse1.add(miquel);
		// studentsCourse1.add(marti);
		// studentsCourse1.add(pol);
		//
		// course1.setStudents(studentsCourse1);

		

		User laura = new User("Laura", "1234");
		User montse = new User("Montse", "1234");
		User alejandro = new User("Alejandro", "1234");
		User ramon = new User("Ramon", "1234");
		User sandra = new User("Sandra", "1234");
		User alex = new User("Alex", "1234");
		User sergio = new User("Sergio", "1234");
		User ingrid = new User("Ingrid", "1234");

		List<User> teachers = new ArrayList<User>();
		teachers.add(laura);
		teachers.add(ingrid);
		course1.setTeachers(teachers);

		teachers = new ArrayList<User>();
		teachers.add(alejandro);
		teachers.add(ramon);
		teachers.add(sandra);
		course2.setTeachers(teachers);

		teachers = new ArrayList<User>();
		teachers.add(laura);
		teachers.add(montse);
		course3.setTeachers(teachers);

		teachers = new ArrayList<User>();
		teachers.add(alex);
		teachers.add(sergio);
		course4.setTeachers(teachers);

		session.save(course1);
		session.save(course2);
		session.save(course3);
		session.save(course4);

		// ArrayList<ItemAgenda> itemAgendaLaura= new ArrayList<ItemAgenda>();
		//
		// itemAgendaLaura.add(new ItemAgenda(space1, course1 , "Tecnologia",
		// new
		// Date(2012, 10, 7, 4, 50)));
		// itemAgendaLaura.add(new ItemAgenda(space2, course2 , "Catala", new
		// Date(2012, 10, 7, 4, 50)));
		// itemAgendaLaura.add(new ItemAgenda(space3, course3 , "Experimentals",
		// new
		// Date(2012, 10, 7, 4, 50)));
		// laura.setItemsAgenda(itemAgendaLaura);
		//
		//
		// for (ItemAgenda item : itemAgendaLaura) {
		// session.save(item);
		// }
		//
		// ArrayList<ItemAgenda> itemAgendaMontse= new ArrayList<ItemAgenda>();
		//
		// itemAgendaMontse.add(new ItemAgenda(space3, course1 , "Laboratori",
		// new
		// Date(2012, 10, 7, 4, 50)));
		// itemAgendaMontse.add(new ItemAgenda(space2, course4 , "Informtica",
		// new
		// Date(2012, 10, 7, 4, 50)));
		// itemAgendaMontse.add(new ItemAgenda(space6, course3 , "Biologia", new
		// Date(2012, 10, 7, 4, 50)));
		// montse.setItemsAgenda(itemAgendaMontse);
		//
		//
		// for (ItemAgenda item : itemAgendaMontse) {
		// session.save(item);
		// }

		session.save(laura);
		session.save(montse);
		session.save(alejandro);
		session.save(ramon);
		session.save(sandra);
		session.save(alex);
		session.save(sergio);

		Notification notification1 = new Notification("Montse",
				"Rebut. Fins dem", new Date(2012, 3, 7, 16, 55));
		Notification notification2 = new Notification("Laura",
				"Dem hi ha reuni", new Date(2012, 3, 7, 16, 50));
		Notification notification3 = new Notification("Montse", new Date(2012,
				2, 2, 11, 4), "Pati", "Avui toca panet de sobrasada");
		Notification notification4 = new Notification("Montse",
				"Avui no vindr, no hem trobu be. Hem sap greu", new Date(2012,
						1, 30, 6, 50));
		Notification notification5 = new Notification("Montse", new Date(2012,
				1, 26, 9, 5), "Lab Quimica",
				"Comenem la practica sobre clorofila");
		Notification notification6 = new Notification("Laura",
				"Estic a un embs, arribare uns 15 minuts tartd", new Date(
						2011, 11, 14, 7, 30));
		Notification notification7 = new Notification("Laura", new Date(2011,
				9, 23, 10, 50), "Biblioteca", "Llegint el Quijote!!");
		Notification notification8 = new Notification("Montse", new Date(2011,
				9, 11, 8, 30), "Sala de Conferencies",
				"Comena la presentacio del Curs");

		Notification notification9 = new Notification("Ramon",
				"Hola, soy Ramon", new Date(2011, 9, 2, 2, 30));
		Notification notification10 = new Notification("Alejandro",
				"Hola, soy Alejandro", new Date(2011, 9, 3, 9, 41));
		Notification notification11 = new Notification("Sandra",
				"Hola, soy Sandra", new Date(2011, 9, 4, 7, 5));
		Notification notification12 = new Notification("Sergio",
				"Hola, soy Sergio", new Date(2011, 9, 5, 8, 45));
		Notification notification13 = new Notification("Alex",
				"Hola, soy Alex", new Date(2011, 9, 6, 9, 50));
		Notification notification14 = new Notification("Pablo",
				"Hola, soy Pablo", new Date(2011, 9, 7, 4, 50));

		session.save(notification1);
		session.save(notification2);
		session.save(notification3);
		session.save(notification4);
		session.save(notification5);
		session.save(notification6);
		session.save(notification7);
		session.save(notification8);
		session.save(notification9);
		session.save(notification10);
		session.save(notification11);
		session.save(notification12);
		session.save(notification13);
		session.save(notification14);

		session.getTransaction().commit();

	}

	public static void main(String[] args) {
		Create();
		System.out.println("--- Taules  creades  ---");
		Insert();
	}
}
