package agora.rest;

import java.util.Date;
import java.util.List;

import javax.ws.rs.Consumes;
import javax.ws.rs.GET;
import javax.ws.rs.PUT;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.Request;
import javax.ws.rs.core.Response;
import javax.ws.rs.core.UriInfo;

import agora.classes.Notification;
import agora.singletons.Singleton;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;

// Feta TOTA amb HIBERNATE
@Path("/notification")
public class NotificationRest {

	private Response response = null;
	private Gson gson = new GsonBuilder().setDateFormat("yyyy-MM-dd").create();

	@Context
	UriInfo uriInfo;

	@Context
	Request request;

	// FETA a HIBERNATE
	@GET
	@Produces(MediaType.TEXT_PLAIN)
	@Path("/all")
	public Response getNotifications() {
		List<Notification> notification = null;
		notification = Singleton.getInstance().getNotifications();	
		System.out.println("Send All notifications");
		response = Response.status(200).entity(gson.toJson(notification)).build();
		return response;
	}
	
	// FETA a HIBERNATE
	@PUT
	@Produces(MediaType.TEXT_PLAIN)
	@Consumes(MediaType.TEXT_PLAIN)
	public Response putNotificationList(@PathParam("username") String username, String notification_String) {
		
		Notification n = gson.fromJson(notification_String, Notification.class);
		n.setDate(new Date(2012, 10, 1, 10, 12));
		Singleton.getInstance().setNotification(n);
		
		System.out.println("Added Notification from User: "+n.getUsername());
		
		response = Response.status(200).entity("Commited").build();
		return response;
	}
}
