package agora.rest;

import java.util.Date;
import java.util.List;

import javax.ws.rs.Consumes;
import javax.ws.rs.GET;
import javax.ws.rs.PUT;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.Request;
import javax.ws.rs.core.Response;
import javax.ws.rs.core.UriInfo;

import agora.classes.ItemAgenda;
import agora.classes.Notification;
import agora.classes.User;
import agora.singletons.Singleton;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;

// Feta TOTA a HIBERNATE
@Path("/user")
public class UserRest {

	private Response response = null;
	private Gson gson = new GsonBuilder().setDateFormat("yyyy-MM-dd").create();

	@Context
	UriInfo uriInfo;

	@Context
	Request request;

	// FETA a HIBERNATE
	@GET
	@Produces(MediaType.TEXT_PLAIN)
	@Path("{username}")
	public Response getUser(@PathParam("username") String username) {
		User u = null;
		u = Singleton.getInstance().getUser(username);
		response = Response.status(200).entity(gson.toJson(u)).build();
		return response;
	}

	// FETA a HIBERNATE
	@GET
	@Path("{username}/pass/{password}")
	@Produces(MediaType.TEXT_PLAIN)
	public Response login(@PathParam("username") String username,
			@PathParam("password") String password) {
		boolean loggedIn = Singleton.getInstance().login(username, password);
		if (loggedIn) {
			response = Response.status(200).entity("true").build();
		} else {
			response = Response.status(400).entity("false").build();
		}
		return response;
	}

	// FETA a HIBERNATE
	@GET
	@Produces(MediaType.TEXT_PLAIN)
	@Path("{coursename}/all")
	public Response getCourse(@PathParam("coursename") String coursename) {
		List<User> users = null;
		users = Singleton.getInstance().getCourseUsers(coursename);

		response = Response.status(200).entity(gson.toJson(users)).build();
		return response;
	}

	// FETA a HIBERNATE
	@PUT
	@Produces(MediaType.TEXT_PLAIN)
	@Consumes(MediaType.TEXT_PLAIN)
	public Response putNotification(@PathParam("username") String username) {

		Notification n = gson.fromJson("", Notification.class);

		Singleton.getInstance().setNotification(n);
		response = Response.status(200).entity("Commited").build();

		return response;
	}

	// @GET
	// @Produces(MediaType.TEXT_PLAIN)
	// @Path("{username}/agenda/{date}")
	// public Response checkUser(@PathParam("username") String
	// username,@PathParam("date") Date date) {
	// ItemAgenda itemagenda = null;
	// itemagenda = Singleton.getInstance().checkUser(username,date);
	//
	// response = Response.status(200).entity(gson.toJson(itemagenda)).build();
	// return response;
	// }

}
