package agora.singletons;

import java.util.List;

import agora.classes.Course;
import agora.classes.Notification;
import agora.classes.Space;
import agora.classes.User;
import agora.database.ConnectorControl;

public class Singleton {

	private static Singleton INSTANCE = null;
	private ConnectorControl conControl;

	private Singleton() {
		conControl = new ConnectorControl();
	}

	private synchronized static void createInstance() {
		if (INSTANCE == null) {
			INSTANCE = new Singleton();
		}
	}

	public static Singleton getInstance() {
		if (INSTANCE == null) {
			createInstance();
		}
		return INSTANCE;
	}

	public boolean login(String username, String password) {
		return conControl.login(username, password);
	}

	public User getUser(String username) {
		return conControl.getUser(username);
	}

	public List<Notification> getNotifications() {
		return conControl.getNotifications();
	}

	public void setNotification(Notification notification) {
		conControl.setNotification(notification);
	}

	public List<Course> getCourses() {
		return conControl.getCourses();
	}

	public List<User> getCourseUsers(String coursName) {
		return conControl.getCourseUsers(coursName);
	}

	public List<Space> getSpaces() {
		return conControl.getSpaces();
	}

	/*
	 * A PARTIR D'AQUI FUNCIONS "CACA" amb utilitat 0 FUNCIONS ToDo
	 */
	
	public void setSpace(Space space) {
		// spaces.add();
	}
	
	
	// public ItemAgenda checkUser(String username, Date date) {
	//
	// Date dt = new Date(0);
	// dt.setHours(10);
	// ItemAgenda ia = new ItemAgenda(dt, "Taller de Tecnologia");
	// return ia;
	// }
}
