package agora.rest;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpDelete;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.client.methods.HttpPut;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.reflect.TypeToken;

import agora.classes.Course;
import agora.classes.ItemAgenda;
import agora.classes.Notification;
import agora.classes.Space;
import agora.classes.User;

public class agoraAPI {

	private HttpClient httpclient;
	private HttpResponse response;

	private BufferedReader bufferedReader;

	private HttpGet get;
	private HttpPut put;
	private HttpPost post;
	private HttpDelete delete;

	private static String URL = "http://192.168.1.133:8080/agora.ESO/rest/";

	private Gson gson;

	public agoraAPI() {
		httpclient = new DefaultHttpClient();
		gson = new GsonBuilder().setDateFormat("yyyy-MM-dd").create();
	}

	/**************  USER  ****************/

	public boolean login(String username, String password) throws ClientProtocolException, IOException {
		get = new HttpGet(URL + "user/" + username +"/"+password);
		response = httpclient.execute(get);

		int code = response.getStatusLine().getStatusCode();

		switch (code) {
		case 200:
			return true;
		case 400:
			return false;
		}
		
		return false;
	}

	public User getUser(String username) throws ClientProtocolException,
			IOException {
		get = new HttpGet(URL + "user/" + username);
		response = httpclient.execute(get);

		int code = response.getStatusLine().getStatusCode();

		bufferedReader = new BufferedReader(new InputStreamReader(response
				.getEntity().getContent()));
		String line = bufferedReader.readLine();

		switch (code) {
		case 200:
			return gson.fromJson(line, User.class);

		case 400:
			break;
		}
		return null;
	}

	public List<User> findUsers(String courseName)
			throws ClientProtocolException, IOException {
		get = new HttpGet(URL + "user/" + courseName + "/all");
		response = httpclient.execute(get);

		int code = response.getStatusLine().getStatusCode();

		bufferedReader = new BufferedReader(new InputStreamReader(response
				.getEntity().getContent()));
		String line = bufferedReader.readLine();

		switch (code) {
		case 200:
			return gson.fromJson(line, new TypeToken<List<User>>() {
			}.getType());
		case 400:
			break;
		}
		return null;
	}

	// informar on es un usuari
	//String username, Space space, String msg, Date date
	public void ckeckin(Notification notification) throws IOException {
		
		put = new HttpPut(URL + "user/");
		String entity = gson.toJson(notification);
		put.setEntity(new StringEntity(entity));

		response = httpclient.execute(put);

		int code = response.getStatusLine().getStatusCode();

		bufferedReader = new BufferedReader(new InputStreamReader(response
				.getEntity().getContent()));
		String line = bufferedReader.readLine();

		switch (code) {
		case 200:
			break;
		case 400:
			break;
		}
	}

	// On hauria d'estar Juan el 25/05/12 12:30
	public ItemAgenda getItemAgenda(String username, Date date) throws IllegalStateException, IOException {
		get = new HttpGet(URL + "itemagenda/" + username +"/"+date);
		response = httpclient.execute(get);

		int code = response.getStatusLine().getStatusCode();

		bufferedReader = new BufferedReader(new InputStreamReader(response
				.getEntity().getContent()));
		String line = bufferedReader.readLine();

		switch (code) {
		case 200:
			return gson.fromJson(line, ItemAgenda.class);

		case 400:
			break;
		}
		return null;
	}
	
	/************** NOTIFICATION ****************/

	public List<Notification> getNotifications()
			throws ClientProtocolException, IOException {
		get = new HttpGet(URL + "notification/all");
		response = httpclient.execute(get);

		int code = response.getStatusLine().getStatusCode();

		bufferedReader = new BufferedReader(new InputStreamReader(response
				.getEntity().getContent()));
		String line = bufferedReader.readLine();

		switch (code) {
		case 200:
			return gson.fromJson(line, new TypeToken<List<Notification>>() {
			}.getType());
		case 400:
			break;
		}

		return null;
	}

	//String username, String msg, Date date
	public void addNotification(Notification notification)
			throws IllegalStateException, IOException {
		
		put = new HttpPut(URL + "notification/");
		String entity = gson.toJson(notification);
		put.setEntity(new StringEntity(entity));

		response = httpclient.execute(put);

		int code = response.getStatusLine().getStatusCode();

		bufferedReader = new BufferedReader(new InputStreamReader(response
				.getEntity().getContent()));
		String line = bufferedReader.readLine();

		switch (code) {
		case 200:
			break;
		case 400:
			break;
		}
	}

	/************** COURSE ****************/

	public List<Course> getCourses() throws ClientProtocolException,
			IOException {
		get = new HttpGet(URL + "course/all");
		response = httpclient.execute(get);

		int code = response.getStatusLine().getStatusCode();

		bufferedReader = new BufferedReader(new InputStreamReader(response
				.getEntity().getContent()));
		String line = bufferedReader.readLine();

		switch (code) {
		case 200:
			return gson.fromJson(line, new TypeToken<List<Course>>() {
			}.getType());
		case 400:
			break;
		}
		return null;
	}

	/************** SPACE ****************/

	public List<Space> getSpaces() throws ClientProtocolException, IOException {
		get = new HttpGet(URL + "space/all");
		response = httpclient.execute(get);

		int code = response.getStatusLine().getStatusCode();

		bufferedReader = new BufferedReader(new InputStreamReader(response
				.getEntity().getContent()));
		String line = bufferedReader.readLine();

		switch (code) {
		case 200:
			return gson.fromJson(line, new TypeToken<List<Space>>() {
			}.getType());
		case 400:
			break;
		}
		return null;
	}



}
